commit:     1ee2c73aa8b5e0f2d951d3687b23824052673042
Author:     Andreas Sturmlechner <asturm <AT> gentoo <DOT> org>
AuthorDate: Tue Jun 21 10:25:05 2022 +0000
Commit:     Andreas Sturmlechner <asturm <AT> gentoo <DOT> org>
CommitDate: Wed Sep 14 14:55:32 2022 +0000
URL:        https://gitweb.gentoo.org/proj/kde.git/commit/?id=1ee2c73a

ecm.eclass: Workaround Portage depgraph shortcomings from revdeps' side

Bug: https://bugs.gentoo.org/836726
Signed-off-by: Andreas Sturmlechner <asturm <AT> gentoo.org>

 eclass/ecm.eclass | 21 ++++++++++++++++++++-
 1 file changed, 20 insertions(+), 1 deletion(-)

diff --git a/eclass/ecm.eclass b/eclass/ecm.eclass
index 5a5b94d349..4549fb6bf8 100644
--- a/eclass/ecm.eclass
+++ b/eclass/ecm.eclass
@@ -218,13 +218,32 @@ case ${ECM_HANDBOOK} in
                ;;
 esac
 
+# Unfortunately, Portage has no concept of BDEPEND=dev-qt/qthelp being broken
+# by having only partially updated Qt dependencies, which means it will order
+# dev-qt/qthelp revdeps in build queue before its own Qt dependencies, leaving
+# qhelpgenerator broken. This is an attempt to help with that. Bug #836726
 case ${ECM_QTHELP} in
        true)
                IUSE+=" doc"
                COMMONDEPEND+=" doc? ( dev-qt/qt-docs:${KFSLOT} )"
                BDEPEND+=" doc? (
                        >=app-doc/doxygen-1.8.13-r1
-                       dev-qt/qthelp:${KFSLOT}
+                       || (
+                               (
+                                       =dev-qt/qtcore-5.15.6*:5
+                                       =dev-qt/qtgui-5.15.6*:5
+                                       =dev-qt/qthelp-5.15.6*:5
+                                       =dev-qt/qtsql-5.15.6*:5
+                                       =dev-qt/qtwidgets-5.15.6*:5
+                               )
+                               (
+                                       =dev-qt/qtcore-5.15.5*:5
+                                       =dev-qt/qtgui-5.15.5*:5
+                                       =dev-qt/qthelp-5.15.5*:5
+                                       =dev-qt/qtsql-5.15.5*:5
+                                       =dev-qt/qtwidgets-5.15.5*:5
+                               )
+                       )
                )"
                ;;
        false) ;;

Reply via email to